package cc.fascinated.bat.features.autorole.command;

import cc.fascinated.bat.command.BatSubCommand;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.features.autorole.profile.AutoRoleProfile;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import cc.fascinated.bat.service.GuildService;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.Role;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component("autoroles:clear.sub")
public class ClearSubCommand extends BatSubCommand {
    private final GuildService guildService;

    @Autowired
    public ClearSubCommand(GuildService guildService) {
        this.guildService = guildService;
    }

    @Override
    public void execute(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull TextChannel channel, @NonNull Member member, @NonNull SlashCommandInteraction interaction) {
        AutoRoleProfile profile = guild.getProfile(AutoRoleProfile.class);

        profile.clearRoles();
        guildService.saveGuild(guild);
        interaction.replyEmbeds(EmbedUtils.buildSuccessEmbed()
                .setDescription("Successfully cleared all auto roles")
                .build()).queue();
    }
}
